/*
Date		: 01/04/2019
Last update : 22/09/2020
*/
module.exports = function() { 

	this.declare=function(_SILENT_MODE,_DISPLAY_DEBUG_NET,_DISPLAY_DEBUG_COM){		
		this.SILENT_MODE 		= _SILENT_MODE;
		this.DISPLAY_DEBUG_NET 	= _DISPLAY_DEBUG_NET;
		this.DISPLAY_DEBUG_COM 	= _DISPLAY_DEBUG_COM;			
	}	
	
	//@TODO 
	this.yaesu3_get_qrg = function(chunk){
	}
	
	//@TODO 
	this.yaesu3_get_mode = function(chunk){  	
	}

	this.yaesu2_get_qrg = function(chunk){
		// 46 41 31 34 31 35 35 30 30 30 3b			
		var buff = chunk.toString('hex');				
		console.log('buff:'+buff);	
		var out = buff.split(',');
		var qrg = '';
		//console.log(out.length); => 11 OK (valid trame) 	
		for (var i = 0; i < out.length; i++) {		
			if(out[i]!=46 && out[i]!=41 && out[i]!=42 && out[i]!='3b')
				qrg+=decodeURI('%'+out[i]);
		}
		console.log('yaesu2_get_qrg extracted :'+qrg);		
		var qrgf = parseInt(qrg,10);	
		qrgf/=10;	
		console.log('yaesu2_get_qrg response to client :'+qrgf);	
		return qrgf;				
	}
	
	//test ok. 
	this.yaesu2_get_mode = function(chunk){  	
		//input :  [ '4d', '44', '30', '33', '3b' ]
		var buff = chunk.toString('hex');			
		console.log('buff:'+buff);	
		var out = buff.split(',');
		var mode = '';
		for (var i = 0; i < out.length; i++) {		
			if(out[i]!='4d' && out[i]!=44 && out[i]!='3b')
			mode+=decodeURI('%'+out[i]);
		}
		console.log('debug mode: '+mode);	
		var final_mode=mode.substring(2,1);
		console.log('yaesu2_get_mode:'+final_mode);			
		return 	final_mode;
	}
	
	this.icom1_getRxMeterData = function(final_hex){
		/*
		Format to return :  
			5   0 to 9  		= >     ex  return 9 
			+10 to +30,40,50 	= >		ex	return 30   
			(0000=S0, 0120=S9, 0241=S9+60dB)	
		*/
		//console.log('input:'+final_hex);
		var capture_item=0;
		var fe_it=0;
		var s_1 = '';
		var s_2 = '';//can be empty :
		for (v in final_hex) {
			var s = final_hex[v];	
			if(s=='fe')fe_it++;
			if(fe_it>=4){capture_item++;}
			if((capture_item >= 6) && s != 'fd'){
				//console.log('@:'+capture_item+' => '+s);
				if(capture_item==6){s_1=s;}
     				if(capture_item==8){s_2=s;}
			   	capture_item++;	
			}
		}
                var f_s = s_1 + s_2;          //EX :  01  and  95 =>  195/255 => 75%
                var f_s_int = parseInt(f_s,10);
		//TEST :  01 20 => S9,   0241 => S9 + 60 
		//s_1 = '01';
		//s_2 = '20';
		/*
		 * From 
		46  S0		
		54  
		...
		123
		133  S9  
		144  +10 
		156  +20 
		170  +30 
		181  +40 
		192  +50 
		204  +60 
		 * */
		s_fin=0;
		if(f_s_int >= 0 && f_s_int <= 46)s_fin=0;
		if(f_s_int >= 47 && f_s_int <= 54)s_fin=1;
		if(f_s_int >= 55 && f_s_int <= 64)s_fin=2;
		if(f_s_int >= 55 && f_s_int <= 64)s_fin=3;
		if(f_s_int >= 65 && f_s_int <= 76)s_fin=4;
		if(f_s_int >= 77 && f_s_int <= 84)s_fin=5;
		if(f_s_int >= 85 && f_s_int <= 94)s_fin=6;
		if(f_s_int >= 95 && f_s_int <= 104)s_fin=7;
		if(f_s_int >= 105 && f_s_int <= 119)s_fin=8;
		if(f_s_int >= 120 && f_s_int <= 133)s_fin=9;
		if(f_s_int >= 134 && f_s_int <= 145)s_fin=10;
		if(f_s_int >= 146 && f_s_int <= 160)s_fin=20;
		if(f_s_int >= 161 && f_s_int <= 170)s_fin=30;
		if(f_s_int >= 171 && f_s_int <= 181)s_fin=40;
		if(f_s_int >= 182 && f_s_int <= 192)s_fin=50;
		if(f_s_int >= 193 && f_s_int <= 255)s_fin=60;
		//console.log(s_fin);
		//console.log(f_s_int);
		return s_fin;
	}

	this.icom1_get_mode = function(final_hex){  	

		//console.log('get mode packet 	('+final_hex+')'); 			
		//console.log('packet.length 	('+final_hex.length+')'); 			
		
		//(fe,fe,58,e0,04,fd,fe,fe,e0,58,04,02,01,fd)		
		//fe,fe,58,e0,03,fd,fe,fe,58,e0,04,fd,fe,fe,e0,58,04,05,01,fd
		
		var trame_number = 0;
		
		if(final_hex.length == 11){		
			//console.log('get,update mode packet (11)'); 		
			trame_number=1;
		}
		//else{
			//console.log('get,only mode packet ('+final_hex.length+')'); 			
		//}	
		
		var d = 0;
		var i = 0;
		var startp=0;
		var extract_mode_id=[];	
		for (v in final_hex) {
			var s = final_hex[v];	
			if(startp){				
				//we capture only second paquet, first is only the ack
				if(trame_number>0 && s != 'fd'){
					if(d>2){
						//remove e0,58:
						console.log( '- ' + s );  		
						extract_mode_id.push(s);			
					}
					d++;
				}	
				if(s == 'fd'){i = 0;startp=0;trame_number++;}
			}
			if(s == 'fe' && i == 1){startp=1;i++;}
			if(s == 'fe'){i=1;}
		}	
		
		//[  0  1  2  3  4  ]
		//  e0,58,04,05,01
		for (i in extract_mode_id) {	
			console.log( 'extract_mode_id[i]' + extract_mode_id[i]+' , i => '+i); 
		}		    
		console.log('icom1_get_mode:'+extract_mode_id);
		
		if(final_hex.length==14){		
			if(isset(extract_mode_id[0]))return extract_mode_id[0];
			else return '';			
		}
		
		if(isset(extract_mode_id[3]))
			return extract_mode_id[3];
		else	
			return '';
		
	}
	
	this.icom1_get_qrg = function(final_hex){  	
		var trame_number = 0;
		if(final_hex.length == 11){		
			console.log('get,update qrg packet (11)'); 		
			trame_number=1;
		}else{
			console.log('get,only qrg packet ('+final_hex.length+')'); 			
		}	
		var d = 0;
		var i = 0;
		var startp=0;
		var extract_qrg_digit=[];
		for (v in final_hex) {
			var s = final_hex[v];	
			if(startp){				
				//we capture only second paquet, first is only the ack
				if(trame_number>0 && s != 'fd'){
					if(d>2){
						//remove e0,58:
						console.log( '- ' + s );  		
						extract_qrg_digit.push(s);			
					}
					d++;
				}	
				if(s == 'fd'){i = 0;startp=0;trame_number++;}
			}
			if(s == 'fe' && i == 1){startp=1;i++;}
			if(s == 'fe'){i=1;}
		}	
		var i 	= 	0;
		var str	=	'';
		var st	=	(extract_qrg_digit.length - 1);
		for (i = st; i > 0; i--) {	
			str+=extract_qrg_digit[i];
		}		
		//000709720	0,9 => ko
		//00709720	1,9 => ok => trame is same as yaesu.
		var str1 = str.substring(1,9);	
		console.log('icom1_get_qrg:'+str);
		return str1;
	}
	//tested beta 1.0.1 : 
	this.kenwood1_get_mode = function(final_hex){  		
		//test rx: 
		//var buff='4946303030323735353530303020202020202b3030303030302037373031303030303038203b';
		console.log('kenwood1_get_mode packet 	('+final_hex+')'); 			
		console.log('kenwood1_get_mode .length 	('+final_hex.length+')'); 			
		var buff = final_hex.toString('hex');		
		var out = buff.split(',');			
		var mode = '';		
		for (var i = 0; i < out.length; i++) {		
			//start to 0,  29=>30 MEAN P9 inside kenwood manual. 
			if(i == 29){
				console.log(i+'=>'+out[i]+'=>'+decodeURI('%'+out[i]));
				var modeid=decodeURI('%'+out[i]);
				console.log('Extract:' + modeid);
				return modeid;
			}						
		}		
		/*
		console.log('kenwood1_get_mode packet 	('+final_hex+')'); 			
		console.log('kenwood1_get_mode .length 	('+final_hex.length+')'); 			
		//remove MD   and   ;    caracters : 
		var buff='';
		for (v in final_hex){buff+=final_hex[v];}
		var s=0;
		var buffn='';
		for (var i = 0; i < buff.length; i++) {
		  var c = buff.charAt(i);
		  if(i==0 && c == 'M'){s++;}
		  if(i==1 && c == 'D'){s++;}
		  if(i>1 && c !=';'){
			buffn+=c;  
		  }
		}
		//Not sure if it's  MD5; or MD05;  ? 
		//https://www.hamradio.co.uk/userfiles/file/Kenwood%20Manuals/TS-570-English.pdf
		//format answer : P1 :  2 =>  05   ?
		var modeid = buffn.substr(1,1); // remove 0 ( P1 ) return only P2. 
		console.log('Extract:' + modeid);
		return modeid;
		*/
	}

	//tested beta 1.0.1 : 
	this.kenwood1_get_qrg = function(final_hex){
		//[ '41',  '30',  '30',  '30',  '32',  '37',  '35',  '35',  '35',  '30',  '30',  '30',  '3b',  '46',  '41',  '30',  '30',  '30' ]
		// 46,41,30,30,30,32,37,35,35,35,30,30,30,3b
		var buff = final_hex.toString('hex');		
		var out = buff.split(',');			
		var qrg = '';
		console.log(out.length);
		console.log('out:'	+	out);
		for (var i = 0; i < out.length; i++) {		
			if(out[i]!=46 && out[i]!=41 && out[i]!=42 && out[i]!='3b'){
				try{
					//console.log('d:'+decodeURI('%'+out[i]));
					qrg+=decodeURI('%'+out[i]);
				}
				catch(err) {
					//console.log(err.message);
				}			
			}		
		}		
		console.log('qrg:'+qrg);
		var qrg = parseInt(qrg,10);	
		qrg/=10;
		console.log('kenwood1_get_qrg:'+qrg);			
		return qrg;	
		
		/*
		if(final_hex.length !=7){ 
			console.log('kenwood1_get_qrg,eror final_hex.length <> 7');
			console.log(final_hex);
			return '';
		}	
		//   7191.50 Khz 
		//    must return : 719150		
		//console.log(final_hex.length);	
		//console.log(final_hex);		
		var buff='';
		for (v in final_hex){buff+=final_hex[v];}
		var s=0;
		var buffn='';
		for (var i = 0; i < buff.length; i++) {
		  var c = buff.charAt(i);
		  if(i==0 && c == 'F'){s++;}
		  if(i==1 && c == 'A'){s++;}
		  if(i>1 && c !=';'){
			buffn+=c;  
		  }
		}	
		var qrg = parseInt(buffn,10);	
		qrg/=10;	
		console.log('kenwood1_get_qrg:'+qrg);	
		return qrg;*/
	}

	this.debugc=function(str,debug_type){
		if(this.SILENT_MODE)return;		
		if(debug_type==0)return;
		console.log(str);
	}
	
	this.c=function(str,dl){
		if(this.SILENT_MODE)return;
		console.log(str);
	}
	
	this.convertHexStrToArrayHex = function(str){
		var a = [];
		for (var i = 0; i < str.length; i += 2) {
			a.push("0x" + str.substr(i, 2));
		}
		return a;
	}

	this.isset = function () {
	  //  discuss at: http://locutus.io/php/isset/
	  // original by: Kevin van Zonneveld (http://kvz.io)
	  // improved by: FremyCompany
	  // improved by: Onno Marsman (https://twitter.com/onnomarsman)
	  // improved by: Rafał Kukawski (http://blog.kukawski.pl)
	  var a = arguments
	  var l = a.length
	  var i = 0
	  var undef
	  if (l === 0) {
		throw new Error('Empty isset')
	  }
	  while (i !== l) {
		if (a[i] === undef || a[i] === null) {
		  return false
		}
		i++
	  }
	  return true
	}	

	this.isFunction = function(obj) {
	  return !!(obj && obj.constructor && obj.call && obj.apply);
	};
		
	this.readNumber = function(num){
		if (num == "one") return 1;
		if (num == "two") return 2;
		if (num == "three") return 3;
		if (num == "four") return 4;
		if (num == "five") return 5;
		if (num == "six") return 6;
		if (num == "seven") return 7;
		if (num == "eight") return 8;
		if (num == "nine") return 9;
		return '';
	}
	
	this.empty = function(e) {
	  switch (e) {
		case "":
		case 0:
		case "0":
		case null:
		case false:
		case typeof this == "undefined":
		  return true;
		default:
		  return false;
	  }
	}

	//based on stackoverflow.com/questions/2405425/is-there-a-sprintf-equivalent-in-javascript
	this.sprintf = function(str) {
		
		var args = arguments, i = 1;

		return str.replace(/%(s|d|0\d+d)/g, function (x, type) {
			var value = args[i++];
			switch (type) {
			case 's': return value;
			case 'd': return parseInt(value, 10);
			default:
				value = String(parseInt(value, 10));
				var n = Number(type.slice(1, -1));
				return '0'.repeat(n).slice(value.length) + value;
			}
		});
		
	}

}
